#include "dino.h"
#include <Imagine/Graphics.h>
#include <algorithm>
using namespace Imagine;

// Q2
Dino::Dino() {
    t = -tJump;
}

// Q3
void Dino::jump(int t0) {
    t = t0;
}
bool Dino::jumping(int t0) const {
    return t<=t0 && t0<=t+tJump;
}

// Q4
int Dino::altitude(int t0) const {
    float h = 0;
    if(jumping(t0)) {
        float x = 1-2*(t0-t)/(float)tJump;
        h=hJump*(1-x*x);
    }
    return h;
}

// Q17
bool Dino::crash(const Ball& b, int t0) const {
    int c = b.center(t0);
    int h = altitude(t0);
    int d2 = (h>hBall/2)? (h-hBall/2)*(h-hBall/2): 0;
    if(c<xDino) {
        c -= xDino;
        d2 += c*c;
    } else if(xDino+wDino<c) {
        c -= xDino+wDino;
        d2 += c*c;
    }
    return 4*d2<hBall*hBall;
}

// Q10
Ball::Ball() {
    set(0, 1000);
}

// Q11
void Ball::set(int t, int x) {
    tInit=t;
    xInit=x;
}

// Q12
int Ball::center(int t) const {
    return xInit-(t-tInit)*speedBall;
}

// Q13
bool Ball::reInit(int t, int xBase) {
    if(center(t)<hBall) {
        tInit= t;
        xInit= std::max(w,xBase+intRandom(1*tJump*speedBall,3*tJump*speedBall));
        return true;
    }
    return false;
}
