#include "recorder.h"
#include <Imagine/Graphics.h>
using namespace Imagine;

const int wBrick=16;

int keyboard() {
    Event e;
    do {
        getEvent(0,e);
        if(e.type==EVT_KEY_ON)
            return e.key;
    } while(e.type!=EVT_NONE);
    return 0;
}

Recorder::Recorder() {
    // Q14
    for(int i=0; i<nBalls; i++)
        b[i].set(0,w+2*i*tJump*speedBall);
    // Q20
    nmax=1;
    actions = new Action[1];
    n=0;
    // Q21
    for(int i=0; i<nBalls; i++) {
        Action a = {0, b[i].center(0), i};
        record(a);
    }
}

// Q20
Recorder::~Recorder() {
    delete [] actions;
}

// Q6, Q9, Q15
void Recorder::display(int t) const {
    noRefreshBegin();
    clearWindow();
    // Bricks Q9
    for(int i=0;i<=w/wBrick;i++)
        drawRect(i*wBrick-t%wBrick, hFloor, wBrick-2, 10, BLACK);
    // Balls Q15
    for(int i=0; i<nBalls; i++)
        fillCircle(b[i].center(t), hFloor-hBall/2, hBall/2, RED);
    // Dino Q6
    float h = dino.altitude(t);
    fillRect(xDino, hFloor-hDino-h, wDino, hDino, BLUE);
    noRefreshEnd();
}

// Q7
void Recorder::action(int t) {
    if(! dino.jumping(t)) {
        int l=keyboard();
        if(l==' ') {
            dino.jump(t);
            Action a = {t, -1, -1}; // Q21
            record(a);
        }
    }
    // Q15
    for(int i=0; i<nBalls; i++)
        if( b[i].reInit(t, b[(i+nBalls-1)%nBalls].center(t)) ) {
            Action a = {t, b[i].center(t), i}; // Q21
            record(a);
        }
}

// Q18
bool Recorder::crash(int t) const {
    for(int i=0; i<nBalls; i++)
        if(dino.crash(b[i],t))
            return true;
    return false;
}

// Q21
void Recorder::record(const Action& a) {
    if(n==nmax) {
        nmax *= 2;
        Action* t = new Action[nmax];
        for(int i=0; i<n; i++)
            t[i] = actions[i];
        delete [] actions;
        actions = t;
    }
    actions[n++] = a;
}

// Q23
void Recorder::set(int t0) {
    // Find jump
    dino = Dino();
    for(int i=n-1; i>=0; i--)
        if(actions[i].t<=t0 && actions[i].x<0) {
            dino.jump(actions[i].t);
            break;
        }
    // Find balls
    for(int j=0; j<nBalls; j++)
        for(int i=n-1; i>=0; i--)
            if(actions[i].t<=t0 && actions[i].i==j) {
                b[j].set(actions[i].t, actions[i].x);
                break;
            }
}
